// git diff HEAD --stat

const spawn = require('child_process').spawn;
const path = require('path');
const fs = require('fs');
const url = require('url');

const puppeteer = require('puppeteer');
const lodash = require('lodash');
const moment = require('moment');
const request = require('request');
const mustache = require('mustache');

const difffn = require('./script/diff');
const walkfn = require('./script/walk');

const workpath = process.cwd();
const serverdomain = process.argv[2] ? process.argv[2].split('=')[1] : 'localhost:7000';

var http = require('http');

const md5 = function () { "use strict"; function n(n, r) { var t = (65535 & n) + (65535 & r), u = (n >> 16) + (r >> 16) + (t >> 16); return u << 16 | 65535 & t } function r(n, r) { return n << r | n >>> 32 - r } function t(t, u, e, o, c, f) { return n(r(n(n(u, t), n(o, f)), c), e) } function u(n, r, u, e, o, c, f) { return t(r & u | ~r & e, n, r, o, c, f) } function e(n, r, u, e, o, c, f) { return t(r & e | u & ~e, n, r, o, c, f) } function o(n, r, u, e, o, c, f) { return t(r ^ u ^ e, n, r, o, c, f) } function c(n, r, u, e, o, c, f) { return t(u ^ (r | ~e), n, r, o, c, f) } function f(r, t) { r[t >> 5] |= 128 << t % 32, r[(t + 64 >>> 9 << 4) + 14] = t; var f, i, a, h, g, l = 1732584193, v = -271733879, d = -1732584194, C = 271733878; for (f = 0; f < r.length; f += 16)i = l, a = v, h = d, g = C, l = u(l, v, d, C, r[f], 7, -680876936), C = u(C, l, v, d, r[f + 1], 12, -389564586), d = u(d, C, l, v, r[f + 2], 17, 606105819), v = u(v, d, C, l, r[f + 3], 22, -1044525330), l = u(l, v, d, C, r[f + 4], 7, -176418897), C = u(C, l, v, d, r[f + 5], 12, 1200080426), d = u(d, C, l, v, r[f + 6], 17, -1473231341), v = u(v, d, C, l, r[f + 7], 22, -45705983), l = u(l, v, d, C, r[f + 8], 7, 1770035416), C = u(C, l, v, d, r[f + 9], 12, -1958414417), d = u(d, C, l, v, r[f + 10], 17, -42063), v = u(v, d, C, l, r[f + 11], 22, -1990404162), l = u(l, v, d, C, r[f + 12], 7, 1804603682), C = u(C, l, v, d, r[f + 13], 12, -40341101), d = u(d, C, l, v, r[f + 14], 17, -1502002290), v = u(v, d, C, l, r[f + 15], 22, 1236535329), l = e(l, v, d, C, r[f + 1], 5, -165796510), C = e(C, l, v, d, r[f + 6], 9, -1069501632), d = e(d, C, l, v, r[f + 11], 14, 643717713), v = e(v, d, C, l, r[f], 20, -373897302), l = e(l, v, d, C, r[f + 5], 5, -701558691), C = e(C, l, v, d, r[f + 10], 9, 38016083), d = e(d, C, l, v, r[f + 15], 14, -660478335), v = e(v, d, C, l, r[f + 4], 20, -405537848), l = e(l, v, d, C, r[f + 9], 5, 568446438), C = e(C, l, v, d, r[f + 14], 9, -1019803690), d = e(d, C, l, v, r[f + 3], 14, -187363961), v = e(v, d, C, l, r[f + 8], 20, 1163531501), l = e(l, v, d, C, r[f + 13], 5, -1444681467), C = e(C, l, v, d, r[f + 2], 9, -51403784), d = e(d, C, l, v, r[f + 7], 14, 1735328473), v = e(v, d, C, l, r[f + 12], 20, -1926607734), l = o(l, v, d, C, r[f + 5], 4, -378558), C = o(C, l, v, d, r[f + 8], 11, -2022574463), d = o(d, C, l, v, r[f + 11], 16, 1839030562), v = o(v, d, C, l, r[f + 14], 23, -35309556), l = o(l, v, d, C, r[f + 1], 4, -1530992060), C = o(C, l, v, d, r[f + 4], 11, 1272893353), d = o(d, C, l, v, r[f + 7], 16, -155497632), v = o(v, d, C, l, r[f + 10], 23, -1094730640), l = o(l, v, d, C, r[f + 13], 4, 681279174), C = o(C, l, v, d, r[f], 11, -358537222), d = o(d, C, l, v, r[f + 3], 16, -722521979), v = o(v, d, C, l, r[f + 6], 23, 76029189), l = o(l, v, d, C, r[f + 9], 4, -640364487), C = o(C, l, v, d, r[f + 12], 11, -421815835), d = o(d, C, l, v, r[f + 15], 16, 530742520), v = o(v, d, C, l, r[f + 2], 23, -995338651), l = c(l, v, d, C, r[f], 6, -198630844), C = c(C, l, v, d, r[f + 7], 10, 1126891415), d = c(d, C, l, v, r[f + 14], 15, -1416354905), v = c(v, d, C, l, r[f + 5], 21, -57434055), l = c(l, v, d, C, r[f + 12], 6, 1700485571), C = c(C, l, v, d, r[f + 3], 10, -1894986606), d = c(d, C, l, v, r[f + 10], 15, -1051523), v = c(v, d, C, l, r[f + 1], 21, -2054922799), l = c(l, v, d, C, r[f + 8], 6, 1873313359), C = c(C, l, v, d, r[f + 15], 10, -30611744), d = c(d, C, l, v, r[f + 6], 15, -1560198380), v = c(v, d, C, l, r[f + 13], 21, 1309151649), l = c(l, v, d, C, r[f + 4], 6, -145523070), C = c(C, l, v, d, r[f + 11], 10, -1120210379), d = c(d, C, l, v, r[f + 2], 15, 718787259), v = c(v, d, C, l, r[f + 9], 21, -343485551), l = n(l, i), v = n(v, a), d = n(d, h), C = n(C, g); return [l, v, d, C] } function i(n) { var r, t = ""; for (r = 0; r < 32 * n.length; r += 8)t += String.fromCharCode(n[r >> 5] >>> r % 32 & 255); return t } function a(n) { var r, t = []; for (t[(n.length >> 2) - 1] = void 0, r = 0; r < t.length; r += 1)t[r] = 0; for (r = 0; r < 8 * n.length; r += 8)t[r >> 5] |= (255 & n.charCodeAt(r / 8)) << r % 32; return t } function h(n) { return i(f(a(n), 8 * n.length)) } function g(n, r) { var t, u, e = a(n), o = [], c = []; for (o[15] = c[15] = void 0, e.length > 16 && (e = f(e, 8 * n.length)), t = 0; 16 > t; t += 1)o[t] = 909522486 ^ e[t], c[t] = 1549556828 ^ e[t]; return u = f(o.concat(a(r)), 512 + 8 * r.length), i(f(c.concat(u), 640)) } function l(n) { var r, t, u = "0123456789abcdef", e = ""; for (t = 0; t < n.length; t += 1)r = n.charCodeAt(t), e += u.charAt(r >>> 4 & 15) + u.charAt(15 & r); return e } function v(n) { return unescape(encodeURIComponent(n)) } function d(n) { return h(v(n)) } function C(n) { return l(d(n)) } function A(n, r) { return g(v(n), v(r)) } function m(n, r) { return l(A(n, r)) } function s(n, r, t) { return r ? t ? A(r, n) : m(r, n) : t ? d(n) : C(n) } return s }();

// 睡眠
const sleep = (time) => {
    return new Promise((resolve, reject) => {
        setTimeout(() => {
            resolve('ok');
        }, time)
    })
};

const write = (dir, json) => {
    return new Promise((resolve, reject) => {
        fs.writeFile(dir, JSON.stringify(json), (err, data) => {
            if (err) {
                reject(err);
            }
            resolve();
        });
    });
}

const read = (dir) => {
    return new Promise((resolve, reject) => {
        fs.readFile(dir, 'utf-8', (err, data) => {
            if (err) {
                // console.log(err)
                reject();
            } else {
                // console.log(data)
                resolve(data);
            }
        });
    });
}

const mkdirsSync = (dirname, mode) => {
    if (fs.existsSync(dirname)) {
        return true;
    } else {
        if (mkdirsSync(path.dirname(dirname), mode)) {
            fs.mkdirSync(dirname, mode);
            return true;
        }
    }
}

// 发送给服务器
const httprequest = (pagename) => {
    return new Promise((resolve, reject) => {
        request({
            url: 'http://localhost:7000/api/getinstance',
            method: "POST",
            json: true,
            headers: {
                "content-type": "application/json",
            },
            body: { name: pagename }
        }, function (error, response, body) {
            if (!error && response.statusCode == 200) {
                resolve(body);
            } else {
                reject(error);
            }
        });
    });
}

const minitype = {
    "": "text/html",
    "css": "text/css",
    "gif": "image/gif",
    "html": "text/html",
    "ico": "image/x-icon",
    "jpeg": "image/jpeg",
    "jpg": "image/jpeg",
    "js": "text/javascript",
    "json": "application/json",
    "pdf": "application/pdf",
    "png": "image/png",
    "svg": "image/svg+xml",
    "swf": "application/x-shockwave-flash",
    "tiff": "image/tiff",
    "txt": "text/plain",
    "wav": "audio/x-wav",
    "wma": "audio/x-ms-wma",
    "wmv": "video/x-ms-wmv",
    "xml": "text/xml"
};

const run = async (urls, pagelist) => {
    console.log(`文件数：${urls.length}`);
    const browser = await (puppeteer.launch({
        // 若是手动下载的chromium需要指定chromium地址, 默认引用地址为 /项目目录/node_modules/puppeteer/.local-chromium/
        executablePath: '/Applications/Chromium.app/Contents/MacOS/Chromium',
        //设置超时时间
        timeout: 15000,
        //如果是访问https页面 此属性会忽略https错误
        ignoreHTTPSErrors: true,
        // 打开开发者工具, 当此值为true时, headless总为false
        devtools: false,
        // 关闭headless模式, 不会打开浏览器
        headless: true
    }));

    let d = new Date;
    let time = moment(d).format('YYYYMMDD-hhmmss');

    let mpath = `./tmp/${time}/`;
    mkdirsSync(mpath);

    let tresult = [];

    // 遍历url
    for (let i = 0, len = urls.length; i < len; i++) {
        try {
            let url = urls[i];
            let page = await browser.newPage();
            await page.setBypassCSP(true);
            await page.setViewport({
                width: 1400,
                height: 1000
            });
            await page.goto(url);

            // 重写 observer 方法
            await page.addScriptTag({
                content: `
                (function () {
                    const getRatioCss = function(img, ratio, elem) {
                        var oratio = img.naturalHeight / img.naturalWidth;
                        if ($(elem).css('position') === 'fixed' || $(elem).closest('.banner-box').css('position') === 'fixed') {
                            let $win = $(window);
                            ratio = $win.height() / $win.width();
                        } else {
                            let iratio = elem.getAttribute('data-resize-ratio');
                            if (iratio) {
                                elem.removeAttribute('data-resize-ratio');
                                ratio = parseFloat(iratio);
                            }
                            if (ratio < 0) {
                                ratio = -ratio / $(window).width() * 100;
                            }
                        }
                        if (oratio < ratio) {
                            reFmtSrc(elem, 'clientHeight', img.naturalHeight, 'h', img.src);
                            return '; width: auto; height: 100%;';
                        } else {
                            reFmtSrc(elem, 'clientWidth', img.naturalWidth, 'w', img.src);
                            return '; width: 100%; height: auto;';
                        }
                    }
                    const reFmtSrc = function(elem, sizeName, size, dir, url) {
                        let pelem = elem.offsetParent;
                        if (pelem) {
                            let psize = pelem[sizeName];
                            if (psize > size) {
                                url = url.replace(/\/(w|h)\d+_original_/, '/' + dir + psize + '_original_');
                                let img = new Image();
                                img.onload = function() {
                                    elem.src = url;
                                }
                                img.src = url;
                            }
                        }
                    }
                    
                    Util.loadImage = function (elem, src, ratio, callback) {
                        if (!src || src === 'null') {
                            return;
                        };
                        if (isNaN(ratio)) {
                            ratio = parseFloat(elem.getAttribute('data-resize-ratio'));
                        }
                        if (!(isNaN(ratio) || ratio === 0)) {
                            elem.style.cssText += getRatioCss(this, ratio, elem);
                            $(elem).removeClass('mg-virtual').siblings('.mg-loading').remove();
                        }
                        src = this.fmtSrc(src, elem);
                        Util.call(callback, elem);

                        elem.onload = function () {
                            elem.onload = null;
                        };
                        elem.onerror = function (msg) {
                            elem.onerror = null;
                        }
                        elem.src = src;
                    }
                    Util.observer = function (elem, handler) {
                        Util.call(handler, elem);
                    }
                })();
                `
            });

            await page.waitForFunction(() => {
                return ModuleManager.isReady;
            }, {
                timeout: 5000
            });

            await page.waitFor(2000);

            // 页面特殊处理
            await page.$$eval('.pre-img, img[data-src]', imgs => {
                [...imgs].forEach((img) => {
                    img.style.backgroundImage = 'none';
                    img.style.backgroundColor = '#999';
                });
            });
            await page.$$eval('.mg-loading', els => [...els].map(el => el.style.display = 'none'));
            await page.$$('img', imgs => {
                [...imgs].forEach((img) => {
                    let w = img.width;
                    let h = img.height;
                    img.style.display = 'inline-block';
                    img.style.backgroundImage = 'none';
                    img.style.backgroundColor = '#999';
                    img.style.width = w;
                    img.style.height = h;
                    img.setAttribute('src', 'data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==');
                });
            });

            // 获取json文件
            let result = await page.evaluate(walkfn);

            // 时间 ， 模块json文件 ，截图
            let pagename = /page=([^&]+)/.exec(url)[1];
            let theme = /theme=([^&]+)/.exec(url)[1];
            let pagepath = `${mpath}${pagename}-${theme}`;
            mkdirsSync(pagepath);

            // 需要对比
            if (pagelist[i]) {
                let basedata = await httprequest(pagelist[i]);
                basedata = basedata.rs.data;
                let md5data = md5(result);
                if (basedata.md5 !== md5data) {
                    let server = JSON.parse(basedata.json);
                    diffrs = difffn(server, result);
                    if (diffrs.length) {
                        await page.screenshot({
                            path: `${pagepath}/local.jpg`,
                            type: 'jpeg',
                            quality: 70,
                            fullPage: true,
                        });

                        await write(`${pagepath}/server.json`, basedata.json);
                        await write(`${pagepath}/diff.json`, diffrs);
                        await write(`${pagepath}/local.json`, result);

                        let content = [];
                        function paintingDiff(dfs) {
                            dfs.forEach((node) => {
                                // let type = node.type;
                                node = node.node || node;
                                // 1 增加， 2 删除， 4 style , 8 text
                                let color = { 1: 'rgba(0,255,0,0.4)', 2: 'rgba(0,0,0,0.4)', 4: 'rgba(255,0,0,0.4)', 8: 'rgba(0,255,255,0.4)' }[4];
                                content.push(`
                                    var div = document.createElement('div');
                                    div.style.position = 'fixed';
                                    div.style.backgroundColor = '${color}';
                                    div.style.left = '${node.rect[0]}px';
                                    div.style.top = '${node.rect[1]}px';
                                    div.style.width = '${node.rect[2]}px';
                                    div.style.height = '${node.rect[3]}px';
                                    div.style.border = '2px solid ${color}';
                                    document.getElementsByTagName('body')[0].appendChild(div);
                                `)
                            });
                        }

                        paintingDiff(diffrs);
                        await page.addScriptTag({ content: content.join('') });

                        await page.screenshot({
                            path: `${pagepath}/diff.jpg`,
                            type: 'jpeg',
                            quality: 70,
                            fullPage: true,
                        });

                        tresult.push({
                            diff: `${pagepath.substr(1)}/diff.jpg`,
                            local: `${pagepath.substr(1)}/local.jpg`,
                            server: `${basedata.imgsrc}`,
                            localdata: JSON.stringify(result),
                            id: basedata._id,
                            md5: md5data
                        });
                    }
                }
            }

            await page.close();
        } catch (e) {
            console.log(e)
        }
    }
    await browser.close();

    http.createServer(async (request, response) => {
        let rs = /\.(png|jpg|jpeg|gif)$/.exec(request.url);
        if (rs === 'ico') {
            response.end('', 'binary');
            return;
        }

        if (/api/.test(request.url)) {
            let id = /id=([^&]+)/.exec(request.url)[1];
            let index = -1;
            tresult.forEach((e, idx) => {
                if (e.id === id) {
                    index = idx;
                }
            });
            !!~index && tresult.splice(index, 1);
            response.end('');
            return;
        }

        let suffix = (rs && rs[1]) || '';
        response.writeHead(200, { 'Content-Type': `${minitype[suffix]}` + (!suffix || suffix === 'html' ? ';charset=utf-8' : '') });

        if (!suffix || suffix === 'html') {
            let template = await read(`./diff-list.html`);
            mustache.parse(template);
            // Then, sometime later.
            let content = mustache.render(template, { data: tresult, datastr: JSON.stringify(tresult), serverdomain: serverdomain });
            response.end(content);
        } else {
            let pathObj = url.parse(request.url, true);
            let staticPath = workpath;
            let filePath = path.join(staticPath, pathObj.pathname);
            if (filePath.indexOf('favicon.ico') === -1) {
                let fileContent = fs.readFileSync(filePath, 'binary');
                response.end(fileContent, 'binary');
            }
        }
    }).listen(7777);

    console.log('Server running at http://localhost:7777/');
}

const diff = spawn('git', ['diff', 'HEAD', '--stat']);
const reg = /^((?:config|js|ftl|theme)[\S]+)\s+\|/;

// 获取模块urllist
const getModuleUrlList = async (obj) => {
    let modules = obj.modules;
    let pagelist = [];

    let getPageFiles = (type) => {
        let urls = [];
        let mappath = path.resolve(workpath, './page/' + type);
        return new Promise((resolve, reject) => {
            fs.readdir(mappath, function (err, files) {
                if (err) {
                    reject(err)
                } else {
                    //遍历读取到的文件列表
                    files.forEach(function (filename) {
                        filename = /^([^\.]+)/.exec(filename)[1];
                        urls.push({
                            page: filename,
                            theme: type
                        });
                    });
                    resolve(urls)
                }
            });
        })
    }

    let files = [];
    let f1 = await getPageFiles('cheng');
    files = files.concat(f1);

    let f2 = await getPageFiles('libo');
    files = files.concat(f2);

    let f3 = await getPageFiles('standard');
    files = files.concat(f3);

    let f4 = await getPageFiles('template4');
    files = files.concat(f4);

    let reg = new RegExp('(data-md|data-mod)="(' + modules.join('|') + ')"', 'im');
    return await (() => {
        return new Promise(async (resolve, reject) => {
            files.forEach(async file => {
                let cnt = await read(`./page/${file.theme}/${file.page}.html`);
                if (reg.test(cnt)) {
                    pagelist.push({
                        page: file.page,
                        theme: file.theme
                    });
                }
            });

            while (!pagelist.length) {
                await sleep(100);
            }

            resolve(pagelist)
        });
    })();
}

// 是否导致模块变化
const isMoudleChange = (obj, files) => {
    // 过滤出对应的ftl模版
    if (obj.ftl) {
        let r = lodash.filter(files.ftl, (f) => {
            let ftl = /ftl\/([^\.]+)\.ftl/.exec(f)[1];
            return ftl === obj.ftl;
        });
        if (r.length) {
            return true;
        }
    }

    if (obj.js) {
        // 过滤出对应的js
        r = lodash.filter(files.js, (f) => {
            return f.includes(obj.js);
        });
        if (r.length) {
            return true;
        }
    }

    if (obj.css) {
        // 过滤出对应的css
        r = lodash.filter(files.css, (f) => {
            return f.split('.')[0].includes(obj.css.split('.')[0]);
        });
        if (r.length) {
            return true;
        }
    }

    // 过滤出风格
    if (obj.theme) {
        for (let i in obj.theme) {
            let flag = isMoudleChange(obj.theme[i], files);
            if (flag) {
                return true;
            }
        }
    }
    return false;
}

// 找模块
const findModuleInfo = (changefiles) => {
    // 通过文件找到对应
    let mappath = path.resolve(workpath, './config/module-map.json');
    return new Promise((resolve, reject) => {
        fs.readFile(mappath, 'utf8', function (err, data) {
            const mapjson = JSON.parse(data);
            let modules = new Set();
            // 处理 ftl , js , css
            for (var key in mapjson) {
                // 暂时不处理
                if (/(common|page)/.test(key) || /page-/.test(key)) {
                    continue;
                } else {
                    // 处理 md- 情况
                    let data = mapjson[key];
                    if (isMoudleChange(data, changefiles)) {
                        modules.add(key);
                    }
                }
            }

            // 处理config
            if (changefiles.config.length) {
                for (let i = 0, len = changefiles.config.length; i < len; i++) {
                    // 只处理config/data里面的数据
                    if (/^config\/data/.test(changefiles.config[i])) {
                        modules.add(/\/([^\.\/]+)\.json$/.exec(changefiles.config[i])[1]);
                    }
                }
            }

            resolve({
                modules: Array.from(modules),
                mapjson
            });
        });
    });
}

// 主流程
const main = async (rs) => {
    let info = await findModuleInfo(rs);
    let list = await getModuleUrlList(info);
    let paramlist = [];
    let urls = [];
    list.forEach((item) => {
        paramlist.push(`${item.page}-${item.theme}`);
        urls.push(`http://localhost:9000/html/page.html?page=${item.page}&theme=${item.theme}`);
    });
    run(urls, paramlist);
}

function delDir(path){
    let files = [];
    if(fs.existsSync(path)){
        files = fs.readdirSync(path);
        files.forEach((file, index) => {
            let curPath = path + "/" + file;
            if(fs.statSync(curPath).isDirectory()){
                delDir(curPath); //递归删除文件夹
            } else {
                fs.unlinkSync(curPath); //删除文件
            }
        });
        fs.rmdirSync(path);
    }
}

process.on("uncaughtException", err => {
    console.log("捕获到异常");
    console.log(err);
    process.exit(1);
});
process.on('SIGINT', function() {
    let paths = path.resolve(workpath, './tmp');
    delDir(paths);
    process.exit(0);
});

diff.stdout.on('data', (data) => {
    let arr = data.toString().split('\n');
    var rs = {
        js: [],
        ftl: [],
        css: [],
        config: []
    };
    for (var i = 0, len = arr.length; i < len; i++) {
        arr[i] = arr[i].trim();
        if (arr[i] && reg.test(arr[i])) {
            let typereg = /\.((\w)+)/g;
            let filename = reg.exec(arr[i])[1];
            let type = typereg.exec(filename)[1];
            switch (type) {
                case 'json':
                    rs.config.push(filename);
                    break;
                case 'scss':
                    rs.css.push(filename);
                    break;
                case 'ftl':
                    rs.ftl.push(filename);
                    break;
                case 'js':
                    // 过滤对应模块
                    if (/^js\/(cheng|libo|standard|template4)\/modules/.test(filename)) {
                        rs.js.push(filename);
                    }
                    break;
            }
        }
    }
    if (!rs.js.length && !rs.ftl.length && !rs.css.length && !rs.config.length) {
        console.log('文件没有任何变动');
    } else {
        request('http://localhost:9000/html/page.html?page=about&theme=standard', (error, response, body) => {
            if (!error && response.statusCode == 200) {
                main(rs);
            } else {
                console.log('请开启本地服务，npm run server');
            }
        });
    }
});

